"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libtool' }"

RBProgramNodeVisitor subclass:#CodeGenerator
	instanceVariableNames:'class protocol source change replacements'
	classVariableNames:''
	poolDictionaries:''
	category:'Interface-Browsers'
!

!CodeGenerator class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2006 by eXept Software AG
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
! !

!CodeGenerator methodsFor:'accessing'!

category:aString

    self protocol: aString

    "Created: / 30-12-2008 / 17:41:44 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 07-07-2009 / 18:46:20 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

change

   change ifNil:[self createChange].
   ^change

    "Created: / 30-12-2008 / 17:14:14 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 07-07-2009 / 18:45:07 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

class:aClass

    class := aClass

    "Created: / 30-12-2008 / 15:38:00 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 07-07-2009 / 18:46:34 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

protocol
    ^ protocol
!

protocol:aString
    protocol := aString.
!

replace: placeholder with: code

    replacements 
        at: placeholder
        put: (code isSymbol 
                ifTrue:[code]
                ifFalse:[RBParser parseRewriteExpression: code])

    "Created: / 07-07-2009 / 18:48:21 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 07-07-2009 / 19:58:51 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

replacementFor: placeholder

    ^replacements 
        at: placeholder
        ifAbsent:[self error:'No replacement for ', placeholder]

    "Created: / 07-07-2009 / 19:13:18 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

source:aString
    source := aString.

    "Created: / 30-12-2008 / 17:04:14 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!CodeGenerator methodsFor:'compiling'!

compile

    ^self change apply

    "Created: / 07-07-2009 / 18:47:52 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!CodeGenerator methodsFor:'initialization'!

initialize
    "Invoked when a new instance is created."

    super initialize.
    replacements := Dictionary new.

    "Created: / 30-12-2008 / 15:29:17 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 07-07-2009 / 18:45:17 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!CodeGenerator methodsFor:'private'!

createChange

    | method |
    method := RBParser parseRewriteMethod: source.
    method source: nil.
    method acceptVisitor: self.
    (change := InteractiveAddMethodChange new)
        class: class
        protocol: protocol
        source: method formattedCode.

    "Created: / 07-07-2009 / 18:44:42 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

replacePlaceholdersInSelectorPartsOf:aMessageNode 
    aMessageNode selectorParts do:[:part | 
        part isPatternVariable ifTrue:[
            |replacement|

            replacement := self replacementFor:part value.
            (replacement isSymbol or:[ replacement isVariable ]) ifFalse:[
                self error:'Replacement for selector parts must be a single selector'
            ].
            part value:replacement formattedCode
        ]
    ]
! !

!CodeGenerator methodsFor:'visitor-double dispatching'!

acceptMessageNode:aMessageNode 
    self replacePlaceholdersInSelectorPartsOf:aMessageNode.
    super acceptMessageNode:aMessageNode.

    "Created: / 07-07-2009 / 19:23:08 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

acceptMethodNode: aMethodNode

    self replacePlaceholdersInSelectorPartsOf: aMethodNode.
    super acceptMethodNode: aMethodNode.

    "Created: / 07-07-2009 / 19:09:11 / Jan Vrany <vranyj1@fel.cvut.cz>"
!

acceptVariableNode: aVariableNode

    aVariableNode isPatternNode ifTrue:
        [aVariableNode replaceWith:
            (self replacementFor:aVariableNode name)]

    "Created: / 30-12-2008 / 17:13:16 / Jan Vrany <vranyj1@fel.cvut.cz>"
    "Modified: / 07-07-2009 / 19:13:55 / Jan Vrany <vranyj1@fel.cvut.cz>"
! !

!CodeGenerator class methodsFor:'documentation'!

version_CVS
    ^ '$Header: /cvs/stx/stx/libtool/CodeGenerator.st,v 1.1 2011-07-01 14:18:53 cg Exp $'
!

version_SVN
    ^ 'Id: CodeGenerator.st 7567 2010-04-17 10:59:53Z vranyj1 '
! !
